#include <bits/stdc++.h>
using namespace std;
int main(){
    int n,q,l,r,i,j,k;
    cin >> n >> q;
    int a[n];
    for(i = 0; i < n; i++)
        cin >> a[i];
    for(i = 0; i < q; i++){
        cin >> l >> r;
        l--;
        r--;
        if(r-l == 1){
            cout << "1\n";
            continue;
        }
        map<int,int> m;
        vector<int> v;
        for(j = l; j <= r; j++){
            for(k = j; k <=r;k++)
            {
                if((a[j]&a[k]) <= (a[j]^a[k])){
                    m[a[j]]++;
                    m[a[k]]++;
                }
            }
        }
        long long sum = 0, am = 0;
        for(const auto& c:m){
            v.push_back(c.second);
            sum+=c.second;
        }
        sort(v.rbegin(),v.rend());
        for(j = 0; j < v.size(); j++){
            am+=v[j];
            if(am*2 == sum){
                cout << (r-l)-(j+1) << "\n";
            }
        }
    }
    return 0;
}